import * as tslib_1 from "tslib";
import * as Library from "../../library/library";
import { Base } from "../../model/common/base";
var Table = (function (_super) {
    tslib_1.__extends(Table, _super);
    function Table(options) {
        var _this = _super.call(this, options) || this;
        _this.columns = Library.init(options, 'columns', new Array());
        return _this;
    }
    Object.defineProperty(Table.prototype, "items", {
        /**
         * items
         * @returns {Array<Name>}
         */
        get: function () {
            return this._items;
        },
        /**
         * items
         * @param items
         */
        set: function (items) {
            if (Library.isArrayWithLength(items)) {
                this._items = items.sort(function (n1, n2) {
                    if (n1.last > n2.last) {
                        return 1;
                    }
                    if (n1.last < n2.last) {
                        return -1;
                    }
                    return 0;
                });
                this.render();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Table.prototype, "columns", {
        /**
         * items
         * @returns {Array<Item>}
         */
        get: function () {
            return this._columns;
        },
        /**
         * columns
         * @param columns
         */
        set: function (columns) {
            if (Library.isArrayWithLength(columns)) {
                this._columns = columns.sort(function (n1, n2) {
                    if (n1.id > n2.id) {
                        return 1;
                    }
                    if (n1.id < n2.id) {
                        return -1;
                    }
                    return 0;
                });
            }
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Render()
     */
    Table.prototype.render = function () {
        var _this = this;
        //
        // Get Table Container
        //
        var container = document.getElementById("idc_table");
        var tbl = document.createElement("table");
        var tblBody = document.createElement("tbody");
        var tblHead = document.createElement("thead");
        var self = this;
        //
        // Iterate through Object Properties
        //
        this.columns.forEach(function (column) {
            var th = document.createElement("th");
            th.innerHTML = "" + column.description;
            tblHead.appendChild(th);
        });
        tblHead.className = 'table-inverse';
        tbl.appendChild(tblHead);
        //
        // Table Attributes
        //
        tbl.className = "table table-bordered table-striped";
        //
        // Loop Through Names
        //
        this.items.forEach(function (name) {
            //
            // Create Row
            //
            var tr = document.createElement("tr");
            //
            // Iterate through Object Properties
            //
            _this.columns.forEach(function (column) {
                var td = document.createElement("td");
                var node = document.createTextNode("" + name[column.name]);
                td.appendChild(node);
                tr.appendChild(td);
            });
            //
            // Append Row
            //
            tblBody.appendChild(tr);
        });
        tbl.appendChild(tblBody);
        container.appendChild(tbl);
    };
    return Table;
}(Base));
export { Table };
//# sourceMappingURL=/Users/admin/Desktop/git/sandbox/typescript/src/model/html/table.js.map